// $Id: LernListen.hh,v 1.11 2004/11/29 17:26:50 christof Exp $
/*  Midgard Character Generator
 *  Copyright (C) 2001 Malte Thoma
 *  Copyright (C) 2003-2008 Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */  

#ifndef _LERNLISTEN_HH
#  define _LERNLISTEN_HH

//#include "Datenbank.hh"
class VAbenteurer;
struct H_WaffeBesitz;
class Abenteurer;
//class Beruf;
#include <string>
#include "Beruf.hh"
#include "Enums.hh"
#include "Spezies.hh"
#include "Ruestung.hh"
#include "Land.hh"

namespace LernListen
{
      bool nsc_check(bool nsc_allowed,bool nsc_only);
      bool nsc_check(const Abenteurer &A,bool nsc_only);

      enum eMBE{MutterSprache,GastlandSprache,NachbarlandSprache,AlteSprache,
                lFach,lAllg,lUnge,lWaff,lZaub,lAngebFert};
//                sFert,sWaff,sZaub,sSpra,sSchr,sWGru,sZWerk};


      bool region_check(const Abenteurer &A, const std::string& region);
      // Fertigkeit ist eine Sprache oder Schrift
      bool SpracheSchrift(const cH_MBE& MBE);                
      
      std::vector<cH_Spezies> getSpezies(bool nsc_allowed);
      std::vector<std::pair<cH_Typen,bool> > getTypen(const Abenteurer& A);
      std::vector<std::pair<cH_Typen,bool> > getTypen(const cH_Spezies &s);
      std::vector<std::pair<cH_Land,bool> > getHerkunft(const Abenteurer& A);
      std::vector<MBE_T::st_zusatz> getLandZusatz();
      std::vector<MBE_T::st_zusatz> getMBEZusatz(const Abenteurer& A,const H_MBEm& MBE);
      std::vector<MBE_T::st_zusatz> getUeberlebenZusatz(); 
      std::vector<MBE_T::st_zusatz> getWaffenZusatz(const std::list<H_MBEm>& WL); 
      std::vector<MBE_T::st_zusatz> getSprachenZusatz(const MBE_T &MBE,const Abenteurer& Aben,bool nachbarland);
      std::vector<MBE_T::st_zusatz> getSchriftenZusatz(const MBE_T &MBE,const Abenteurer& Aben);
      std::vector<std::string> getSpezialgebiet(const Abenteurer& A);
      std::list<H_MBEm> getBeruf(const Abenteurer& A);
      std::vector<Beruf::st_vorteil> getBerufsVorteil(const H_MBEm& beruf,const BerufsKategorie &BKat,const Abenteurer& A);
      std::vector<cH_Ruestung> getRuestung(const Abenteurer& A);

      std::list<H_WaffeBesitz> getWaffenBesitz(const Abenteurer& Aben);

      std::list<H_LSE> getMBEm(const Abenteurer& A,eMBE was, int erfolgswert=0, int lernpunkte=0);
      void filterLearned(std::list<H_LSE> &liste, Abenteurer const& A);

      std::list<cH_MBE> get_steigern_MBE(const Abenteurer& A,MBE_T::MBEE was);
      // beschwörung ... ist das nicht eine Region?
      std::list<cH_MBE> get_steigern_Zauberliste(const Abenteurer& A,
            bool salz,bool beschwoerung, bool alle,bool spruchrolle);
      std::list<cH_MBE> get_steigern_ZauberWerkliste(const Abenteurer& A,
            bool alle);
      void shorten_for_GFP(std::list<cH_MBE> &L,const Abenteurer& A,const int gfp);
};
#endif
