/*  Midgard Character Generator
 *  Copyright (C) 2001-2002 Malte Thoma
 *  Copyright (C) 2003	    Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

//#include "config.h"
#include "zufall_steigern.hh"
#include "Zufall.hh"
#include "KI.hh"
#include "Optionen.hh"
#include <Misc/itos.h>
#include "Prototyp.hh"
#include "Random.hh"
#include "Datenbank.hh"

unsigned zufall_steigern::GFPvonGrad(unsigned grad)
{  const Grad_anstieg &GA=Datenbank.GradAnstieg;
   return Random::integer(GA.getGFP(grad),GA.getGFP(grad+1)-1);
}

void zufall_steigern::steigern(Abenteurer &A, unsigned gfp)
{
  assert(A.Typ1()->Valid());
//  check100();
  prozente100.check100();
  Prototyp::setLast(prozente100);
  int oldAEP=A.AEP();
  int oldKEP=A.KEP();
  int oldZEP=A.ZEP();
  int oldGS=A.Gold();
  
  if (A.GFP()>=gfp) return;
  gfp-=A.GFP();

  A.setKEP(0);
  A.setZEP(0);
  A.setAEP(gfp);
  A.setGold(gfp*10);

  if(prototypen.empty())
     MagusKI(A).VerteileGFP(gfp,prozente100,GSA_MBE);
  else
   {
     MagusKI(A).VerteileGFP(gfp,prozente100,prototypen);
   }
  A.setAEP(oldAEP);
  A.setZEP(oldZEP);
  A.setKEP(oldKEP);
  A.setGold(oldGS);
}

