/*  MAGuS: Midgard Abenteurer Generieren Und Steigern
 *  Copyright (C) 2002 Malte Thoma
 *  Copyright (C) 2004-2007 Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _TABLE_LERNSCHEMA_HH
#  include "table_lernschema_glade.hh"
#  define _TABLE_LERNSCHEMA_HH

#include "class_lernpunkte.hh"
#include "MidgardBasicElement.hh"
class AusruestungBaum;
class midgard_CG;
class AbenteurerAuswahl;
//#include "Waffe.hh"
//#include "Beruf.hh"
#include <libmagus/AbenteurerLernpunkte.hh>

namespace Glib { class MainLoop; }

class table_lernschema : public table_lernschema_glade
{
//public:
	enum GWR_Auswahl {ENone,EGeld1,EGeld2,EGeld3,EWaffen,ERuestung};
private:
        AbenteurerAuswahl *vabenteurer;
        midgard_CG *hauptfenster;
        // AbenteurerLernpunkte abent_lernpunkte;

        GWR_Auswahl gwr_auswahl;
//        std::list<std::string> list_FertigkeitZusaetze;
        WaffeBesitzLernen waffebesitzlernen;
        MidgardBasicTree *tree_lernschema;
        SimpleTree *Beruf_tree;
        MidgardBasicTree *tree_angeb_fert;
        MidgardBasicTree *tree_kido_lernschema;
        MidgardBasicTree *tree_waffen_lernschema;
        std::list<H_MBEm> list_Fertigkeit_ang_neu;
        // erforderlich um bei erlaubt/unerlaubt (nicht) alle darstellen zu können
        std::vector<MBE_T::st_zusatz> datavec_zusatz;
        //sigc::connection connection;
        MBE_T::st_zusatz const*ausgewaehlt;
	Glib::RefPtr<Glib::MainLoop> runloop;

private:
       void show_datavec_zusatz();
       MBE_T::st_zusatz lernen_zusatz(MBE_T::eZusatz was,H_MBEm _MBE);
       void lernen_zusatz_titel(MBE_T::eZusatz was,const H_MBEm& MBE);

       void set_gwr_eingabe();
       void on_herkunft_leaf_selected(cH_RowDataBase d);
       void on_herkunft_ueberleben_leaf_selected(cH_RowDataBase d);
       void on_tree_lernschema_leaf_selected(cH_RowDataBase d, bool &processed);
       void on_zusatz_leaf_selected(cH_RowDataBase d);
       void on_zusatz_leaf_sprache_selected(cH_RowDataBase d);
       void on_zusatz_leaf_schrift_selected(cH_RowDataBase d);
       void set_zusatz_sensitive(bool an);
       void show_gelerntes();
       void show_lernschema();
       void zeige_lernpunkte();
       void set_lernpunkte();
       void button_sensitive(bool b);
       void edit_lernpunkte(bool b);
       void zeige_werte();
       void lernschema_geld_wuerfeln(const std::vector<int>& VGeldwurf);
       void geld_wuerfeln();
       void on_button_ruestung_clicked(int wurf);
       void setTitels_for_Lernschema(const MBE_T::MBEE& what,MBEm_T::wie_erlernt::lernen_t liste);
       void clean_lernschema_trees();

       // Beruf
       void deleteBerufsFertigekeit();
       void showBerufsLernList();
       void beruf_gewuerfelt(int wurf);
       void on_beruf_tree_leaf_selected(cH_RowDataBase d);

       // Fertigkeiten
       void on_angeborene_fertigkeit_clicked();
       void on_angeborene_fertigkeit_right_clicked();
       void on_ang_fert_leaf_selected(cH_RowDataBase d);
       std::string AngebFert_gewuerfelt(int wurf);
       void lernpflichten_info();

       // Waffen
       void show_WaffenBesitz_lernschema();
       void on_waffen_lernschema_tree_leaf_selected(cH_RowDataBase d);
       void WaffenBesitz_lernschema_wuerfeln(int wurf);
       void on_togglebutton_spezialwaffe_toggled();

       // Zauber
       void show_magier_spezialgebiet(bool show);
       void spezialgebiet_button_fill();
//       void spezialgebiet_button();

       // KiDo
       void fill_kido_lernschema();
       void on_tree_kido_lernschema_leaf_selected(cH_RowDataBase d);

       // Ausrüstung
//       void setStandardAusruestung();
//       void setFertigkeitenAusruestung(AusruestungBaum &Rucksack);
       void setFertigkeitenAusruestung();
       void InfoFensterAusruestung(const std::string &fert_name,
                        const std::string &gegen_name,int wurf,int noetig);

      // Ab hier die automatischen Methoden von glade erzeugt
private:
        void on_combo_kido_stil_activate();
        bool on_combo_kido_stil_focus_out_event(GdkEventFocus *ev);
        void on_combo_magier_spezialgebiet_activate();
        bool on_combo_magier_spezialgebiet_focus_out_event(GdkEventFocus *ev);
        void on_button_waffe_trans_clicked();
        void on_button_fach_trans_clicked();
        void on_spinbutton_fach_activate();
        bool on_spinbutton_fach_focus_out_event(GdkEventFocus *ev);
        bool on_spinbutton_fach_focus_in_event(GdkEventFocus *ev);
        void on_lernliste_wahl_toggled();
        void on_spinbutton_allgemein_activate();
        bool on_spinbutton_allgemein_focus_out_event(GdkEventFocus *ev);
        bool on_spinbutton_allgemein_focus_in_event(GdkEventFocus *ev);
        void on_spinbutton_waffen_activate();
        bool on_spinbutton_waffen_focus_out_event(GdkEventFocus *ev);
        bool on_spinbutton_waffen_focus_in_event(GdkEventFocus *ev);
        void on_button_waffen_clicked();
        void on_spinbutton_zaubern_activate();
        bool on_spinbutton_zaubern_focus_out_event(GdkEventFocus *ev);
        bool on_spinbutton_zaubern_focus_in_event(GdkEventFocus *ev);
        void on_spinbutton_unge_activate();
        bool on_spinbutton_unge_focus_out_event(GdkEventFocus *ev);
        bool on_spinbutton_unge_focus_in_event(GdkEventFocus *ev);
        void on_kido_wahl_clicked();
        void on_tree_gelerntes_leaf_selected(cH_RowDataBase d);
        void on_herkunftsland_clicked();
        void on_button_angeborene_fertigkeit();
        void on_lernpunkte_wuerfeln_clicked();
        void on_togglebutton_lernpunkte_edit_toggled();
        void on_button_beruf();
        void on_spinbutton_beruf_activate();
        bool on_spinbutton_beruf_focus_in(GdkEventFocus *ev);
        void on_entry_berufsname_activate();
        void on_button_lernschema_geld();
        void on_button_lernschema_waffen();
        void on_spinbutton_waffen_lernschema_activate();
        bool on_spinbutton_waffen_lernschema_focus_in_event(GdkEventFocus *ev);
        void on_button_ruestung();
        void on_button_ausruestung();
        void ausruestung_setzen();
        void on_togglebutton_teure_anzeigen_toggled();
        void on_togglebutton_gelernte_anzeigen_toggled();
        void on_togglebutton_einschraenkungen_zusatz_anzeigen_toggled();
        bool on_eventbox_zusatz_leave_notify_event(GdkEventCrossing *ev);
        void on_combo_magier_changed();
        void on_combo_kido_stil_changed();
	void on_auswahl(cH_RowDataBase row,bool &handled);

        void refresh();
        bool wizard_changed_delayed();
	void wizard_changed(gpointer);
public:
	static MBE_T::st_zusatz const& Auswahl_neu(void* obj,
                std::vector<MBE_T::st_zusatz> const& list, std::string const& title);
        table_lernschema(GlademmData *_data);
        void init(midgard_CG *hauptfenster);
};
#endif
